Attribute VB_Name = "C500SUBS"
'Global command declaration
Global Command_Type
Global Addr
Global Axis


'*** this needs to be the right path
'this is a test function for the dll, it adds 1 to a number
Declare Function Test Lib "in_out32.dll" (ByVal Numb%) As Integer
'similar to the Out command in QuickBASIC
Declare Sub Out Lib "in_out32.dll" (ByVal Addr%, ByVal Numb%)
'similar to the Inp command in QuickBASIC
Declare Function Inp Lib "in_out32.dll" (ByVal Addr%) As Integer


Function SetAccel(Hex_Address, Axis, NUMBER)
 If (SendASCII(Hex_Address, Axis, "A")) Then SetAccel = 1
 If (SendBinary(Hex_Address, Axis, NUMBER, 1)) Then SetAccel = 1
End Function

Function BaseRate(Hex_Address, Axis, BaseSpeed, MaxSpeed)
'this selects the appropriate base rate setting
'AA use only

  crystal! = 11000000#
 
  FactorA = Int(crystal! / (Max_Speed * (8100 - 30 * 255)))
 
  BaseRte = Int((8100 - crystal! / (Base_Speed * FactorA)) / 30 + 0.5)
  If BaseRte < 1 Then BaseRte = 1
  BaseRate = BaseRte
End Function

Function BaseSpd(Hex_Address, Axis, NUMBER)
'this send the base rate
'AA use only
 If (SendASCII(Hex_Address, Axis, "B")) Then BaseSpd = 1
 If (SendBinary(Hex_Address, Axis, NUMBER, 1)) Then BaseSpd = 1
End Function

Function AxisBusy(Hex_Address, Axis)
'this will return a 1 if it is BUSY meaning LOW
'this will return a 0 if it is not BUSY meaning HIGH

a = Inp(Hex_Address)                          'BUSY is the odd bit here
  If Axis = 1 Then
        If a Mod 2 = 1 Then
                AxisBusy = 0
        Else
                AxisBusy = 1
        End If
  Else
        If a >= 8 Then a = a - 8
        If a >= 4 Then
                AxisBusy = 0
        Else
                AxisBusy = 1
        End If
  End If
End Function

Function ByteCount(a$)
'this counts the bytes for programming the SMC20.
'AA use only

        Select Case a$

        Case "ACCL"
        ByteCount = 2

        Case "BASE"
        ByteCount = 6

        Case "DECL"
        ByteCount = 2

        Case "GO"
        ByteCount = 1
     
        Case "GOTO"             'LIKE A LOOP WITH A 0
        ByteCount = 3

        Case "HOME"
        ByteCount = 2

        Case "INPT"
        ByteCount = 3
    
        Case "LOOP"
        ByteCount = 3

        Case "MAX"
        ByteCount = 6
     
        Case "NUM"
        ByteCount = 3

        Case "OUT"
        ByteCount = 3
     
        Case "POS"
        ByteCount = 3

        Case "QUIT"
        ByteCount = 1
     
        Case "UNTL"             '(WAIT)
        ByteCount = 2
     
        Case "WAIT"             '(EXPEND)
        ByteCount = 3
     
        Case "SETZ"
        ByteCount = 1

        Case "DIR+"
        ByteCount = 1
      
        Case "DIR-"
        ByteCount = 1
       
        Case Else
        ByteCount = 0

        End Select

End Function

Function SetCCW(Hex_Address, Axis)
   If (SendASCII(Hex_Address, Axis, "-")) Then SetCCW = 1
End Function

Function SetCW(Hex_Address, Axis)
   If (SendASCII(Hex_Address, Axis, "+")) Then SetCW = 1
End Function

Function DBInOut(Hex_Address, Axis)
'this will return a 1 if it is ready to SEND data meaning LOW
'this will return a 0 if it is ready to RECEIVE data meaning HIGH
'AA use only

  
  a = Inp(Hex_Address)
  If Axis = 1 Then
    If a >= 8 Then a = a - 8
        If a >= 4 Then a = a - 4
        If a >= 2 Then
                DBInOut = 0
        Else
                DBInOut = 1
        End If
  Else                                    'Axis = 2
        If a >= 8 Then
                DBInOut = 0
        Else
                DBInOut = 1
        End If
  End If
End Function

Function SetDecel(Hex_Address, Axis, NUMBER)
 If (SendASCII(Hex_Address, Axis, "D")) Then SetDecel = 1
 If (SendBinary(Hex_Address, Axis, NUMBER, 1)) Then SetDecel = 1
End Function

Function SetFactor(Hex_Address, Axis, NUMBER)
 If (SendASCII(Hex_Address, Axis, "F")) Then SetFactor = 1
 If (SendBinary(Hex_Address, Axis, NUMBER, 1)) Then SetFactor = 1
End Function

Sub FinishMove(Hex_Address, Axis)
        While AxisBusy(Hex_Address, Axis)
        Wend
End Sub

Function GetBaseSpeed(Hex_Address, Axis)
        'this returns the actual base speed

  If (SendASCII(Hex_Address, Axis, "VF")) Then GetBaseSpeed = 1
  FactorC = ReceiveByte(Hex_Address, Axis)

  If (SendASCII(Hex_Address, Axis, "VB")) Then GetBaseSpeed = 1
  BaseRte = ReceiveByte(Hex_Address, Axis)

  crystal! = 11000000#

  GetBaseSpeed = (crystal! / (FactorC * (8100 - 30 * BaseRte)))
        'this calculates the actual speed
End Function

Function GetInput(Hex_Address, InputValue)
   Dim Address
   
   Address = Hex_Address + 6
   Value = 63 - Inp(Address)
   Result = (Value \ (2 ^ (InputValue - 1)) And 1)
   GetInput = Result

End Function

Function GetInputs(Hex_Address)
    Dim Address

    Address = Hex_Address + 6
    GetInputs = (63 - Inp(Address))
End Function

Function GetMaxSpeed(Hex_Address, Axis)
'this returns the actual max speed

  If (SendASCII(Hex_Address, Axis, "VF")) Then GetMaxSpeed = 1
  Factor_B = ReceiveByte(Hex_Address, Axis)

  If (SendASCII(Hex_Address, Axis, "VM")) Then GetMaxSpeed = 1
  MaxRte = ReceiveByte(Hex_Address, Axis)

  crystal! = 11000000#

  GetMaxSpeed = (crystal! / (Factor_B * (8100 - 30 * MaxRte)))
        'this calculates the actual speed

End Function

Function HomeType(Hex_Address, Axis, Value)
 If (SendASCII(Hex_Address, Axis, "H")) Then HomeType = 1
 If (SendBinary(Hex_Address, Axis, NUMBER, 1)) Then HomeType = 1
End Function

Function GoRelative(Hex_Address, Axis)
  Dim Address
  
  Address = Hex_Address
  If (SendASCII(Address, Axis, "G")) Then GoRelative = 1
End Function
Function SetBase(Hex_Address, Axis, Value)
 If (SendASCII(Hex_Address, Axis, "B")) Then SetBase = 1
 If (SendBinary(Hex_Address, Axis, Value, 2)) Then SetBase = 1
End Function

Function SetDistance(Hex_Address, Axis, Value)
 If (SendASCII(Hex_Address, Axis, "N")) Then SetDistance = 1
 If (SendBinary(Hex_Address, Axis, Value, 2)) Then SetDistance = 1
End Function

Function SetMax(Hex_Address, Axis, Value)
 If (SendASCII(Hex_Address, Axis, "M")) Then SetMax = 1
 If (SendBinary(Hex_Address, Axis, Value, 1)) Then SetMax = 1
End Function

Function SetMotion(Hex_Address, Axis, BaseSpeed, MaxSpeed)
  crystal! = 11000000#
  If BaseSpeed > 20000 Then BaseSpeed = 20000
  If BaseSpeed < 5 Then BaseSpeed = 5
  If MaxSpeed > 24444 Then MaxSpeed = 24444
  If MaxSpeed < 100 Then MaxSpeed = 100

  FactorA = Int(crystal! / (MaxSpeed * (8100 - 30 * 255)))
        'truncated not rounded
        'this calculates the highest factor that can be used

'  PRINT "Factor: "; Factor_A

  MaxRte = Int((8100 - crystal! / (MaxSpeed * FactorA)) / 30 + 0.5)
        'this calculates the closest speed to that chosen
        'this rounds to the closest speed

'  PRINT "Max_Rate: "; Max_Rte

  BaseRte = Int((8100 - crystal! / (BaseSpeed * FactorA)) / 30 + 0.5)
        'this calculates the closest speed to that chosen
        'this rounds to the closest speed
  If BaseRte < 1 Then BaseRte = 1
        'this is the case that the base speed asked for is too small
  If BaseRte > 254 Then BaseRte = 254

'  PRINT "BaseRate: "; Base_Rte

  If (SetBase(Hex_Address, Axis, BaseRte)) Then SetMotion = 1
  If (SetMax(Hex_Address, Axis, MaxRte)) Then SetMotion = 1
  If (SetFactor(Hex_Address, Axis, FactorA)) Then SetMotion = 1
End Function

Function NumberOfAxes(Hex_Address)
    Dim Address
'this function will send an INDEX NUMBER to each potential axis
'if the number can be read back, then that axis is indeed valid.
'this function will return a 1 if axis 1 is valid
'                          a 2 if axis 1 and axis 2 is valid
'                          a 99 if axis 1 is NOT valid but axis 2 is

'AXIS 2 TEST
  NUMBER = 12345
  Axis = 1
  Add_Hand_Shake = Hex_Address + 1
  ADD_LATCH = Hex_Address + 3

'SEND "N"
  a$ = "N"
  If SendASCII(Hex_Address, Axis, a$) Then GoTo NoAxis
'SEND NUMBER
  If SendBinary(Hex_Address, Axis, NUMBER, 2) Then GoTo NoAxis
'SEND "VN"
    a$ = "VN"
    If SendASCII(Hex_Address, Axis, a$) Then GoTo NoAxis
'RECEIVE NUMBER
  Address = Hex_Address + 2
  While AxisBusy(Hex_Address, Axis)
  Wend
  Out Hex_Address + 1, 5   'A:I/O REQ LOW, B:I/O REQ HI, write control HIGH
  Do
     DBCheck = Inp((Hex_Address) And 3)
  Loop Until (DBCheck = 0)
  'debug - put next line back in
  c = Inp(Address)                          'read the data
  
  Out Hex_Address + 1, 7   'A:I/O REQ HI, B:I/O REQ HI, write control HIGH
  While AxisBusy(Hex_Address, Axis)
  Wend
  Out Hex_Address + 1, 5   'A:I/O REQ LOW, B:I/O REQ HI, write control HIGH
  Do
    DBCheck = Inp((Hex_Address) And 3)
  Loop Until (DBCheck = 0)
  
  b = Inp(Address)
  c = c + b * 256
 
NoAxis:
  AxesCount = 0
  Out Hex_Address + 1, 7   'A:I/O REQ HI, B:I/O REQ HI, write control HIGH
  
  While AxisBusy(Hex_Address, Axis)
  Wend
  
  If c = 12345 Then AxesCount = 1


'AXIS 2 TEST
  Add_Hand_Shake = Hex_Address + 1
  ADD_LATCH = Hex_Address + 5
  D$ = "N"
  NUMBER = 54321
  Axis = 2

'SEND "N"
    While AxisBusy(Hex_Address, Axis)
    Wend
    If (SendASCII(Hex_Address, Axis, D$)) Then GoTo NoAxis2
'SEND NUMBER
    If (SendBinary(Hex_Address, Axis, NUMBER, 2)) Then GoTo NoAxis2
'SEND "VN"
    D$ = "VN"
    If (SendASCII(Hex_Address, Axis, D$)) Then GoTo NoAxis2
'RECEIVE NUMBER
    Address = Hex_Address + 4
    
    While AxisBusy(Hex_Address, Axis)
    Wend
    
    Out Hex_Address + 1, 3   'A:I/O REQ HI, B:I/O REQ LOW, write control HIGH
    Do
      DBCheck = Inp((Hex_Address) And 12)
    Loop Until (DBCheck = 0)
    c = Inp(Address)                          'read the data
    
    Out Hex_Address + 1, 7   'A:I/O REQ HI, B:I/O REQ HI, write control HIGH
    
    While AxisBusy(Hex_Address, Axis) = 1 'Wait For Not Busy
    Wend
      
       
    
    Out Hex_Address + 1, 3   'A:I/O REQ HI, B:I/O REQ LOW, write control HIGH
    Do
      DBCheck = Inp((Hex_Address) And 12)
    Loop Until (DBCheck = 0)
    
    b = Inp(Address)
    c = c + b * 256
    Out Hex_Address + 1, 7   'A:I/O REQ HI, B:I/O REQ HI, write control HIGH
NoAxis2:
  If (c = 54321) And (AxesCount = 1) Then AxesCount = 2
  If (c = 54321) And (AxesCount = 0) Then AxesCount = 99

  'IF NUM_OF_AXES = 99 THEN SOMETHING IS WRONG WITH AXIS 1 BUT AXIS 2 IS OK
 
   NumberOfAxes = AxesCount

End Function

Sub Pause()
a = Timer
While Timer - a < 0.1
Wend

End Sub

Function SetPosition(Hex_Address, Axis, NUMBER)

 If (SendASCII(Hex_Address, Axis, "P")) Then SetPosition = 1
 If (SendBinary(Hex_Address, Axis, NUMBER, 2)) Then SetPosition = 1
End Function

Function QuitProgram(Hex_Address, Axis)
     If (SendASCII(HexAddress, Axis, "Q")) Then QuitProgram = 1
End Function

Function ProgramRun()
  Dim Address
  Axis = 1
  Address = &H300
  If (SendASCII(Address, Axis, "R")) Then ProgramRun = 1
  If (SendBinary(Address, Axis, 0, 1)) Then ProgramRun = 1
End Function

Function ReceiveByte(Hex_Address, Axis)
    Dim Address
'this is to receive one byte of data from the smc20 chip
'AA use only

        'we check for the busy to be HIGH
        'then we bring the i/o req low (meaning ready)
        'the smc20 brings the busy low and we check for this
        'then we read the data
        'then we bring the i/o req high
 
   If Axis = 1 Then
        Address = Hex_Address + 2
   Else                                 'Axis = 2
        Address = Hex_Address + 4
   End If

While AxisBusy(Hex_Address, Axis)          'wait for the chip to not be BUSY
Wend

If Axis = 1 Then
  Out Hex_Address + 1, 5   'A:I/O REQ LOW, B:I/O REQ HI, write control HIGH
  Do
     DBCheck = Inp((Hex_Address) And 3)   'Wait for reversal of data bus
  Loop Until (DBCheck = 0)
  
  a = Inp(Address)                          'read the data
  Out Hex_Address + 1, 7   'A:I/O REQ HI, B:I/O REQ HI, write control HIGH
                        'resets i/o req
                        'disables data from the smc20's bus
   Do
     DBCheck = Inp((Hex_Address) And 1)
  Loop Until (DBCheck = 0)
  ReceiveByte = a

Else            'axis = 2
  Out Hex_Address + 1, 3   'A:I/O REQ HI, B:I/O REQ LOW, write control HIGH
  Do
     DBCheck = Inp((Hex_Address) And 12)
  Loop Until (DBCheck = 0)
  
  a = Inp(Address)                          'read the data
  Out Hex_Address + 1, 7   'A:I/O REQ HI, B:I/O REQ HI, write control HIGH
                        'resets i/o req
                        'disables data from the smc20's bus
  RecieveByte = a
End If

End Function

Function SendASCII(Hex_Address, Axis, a$)

'AA use only
'This function will "hang up" if the chip is in motion - like a HOME or INDEX
'this can be avoided by checking the BUSY before issuing the command

If Axis = 1 Then
  Add_Hand_Shake = Hex_Address + 1
  ADD_LATCH = Hex_Address + 3
  
  For X = 1 To Len(a$)
     StartTime = Timer
    While AxisBusy(Hex_Address, Axis) = 1   'wait for the chip to not be BUSY
       If Timer - StartTime > 0.1 Then SendASCII = 1: Exit Function
    Wend                                '(a logic 1)
    Out Add_Hand_Shake, 6    'this sets the A:I/O REQ to HI, B:I/O REQ to HI
                             'write control to LOW
    Out ADD_LATCH, Asc(Mid$(a$, X, 1))  'this latches the data on U7
    Out Add_Hand_Shake, 4 'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
      StartTime = Timer
    While AxisBusy(Hex_Address, Axis) = 0     'wait for the chip to be BUSY
       If Timer - StartTime > 0.1 Then SendASCII = 1: Exit Function
    Wend                                  '(a logic 0) (it accepts the data)
    Out Add_Hand_Shake, 7  'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                        'resets i/o req and disables data from the smc20's bus
  Next X
End If

If Axis = 2 Then
  Add_Hand_Shake = Hex_Address + 1
  ADD_LATCH = Hex_Address + 5
  For X = 1 To Len(a$)
  StartTime = Timer
  While AxisBusy(Hex_Address, Axis) = 1   'wait for the chip to not be BUSY
     If Timer - StartTime > 0.1 Then SendASCII = 1: Exit Function
  Wend
  Out Add_Hand_Shake, 6 'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
  Out ADD_LATCH, Asc(Mid$(a$, X, 1))  'this latches the data on U7
  Out Add_Hand_Shake, 2 'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
  StartTime = Timer
  While AxisBusy(Hex_Address, Axis) = 0     'wait for the chip to be BUSY (accept the data)
     If Timer - StartTime > 0.1 Then SendASCII = 1: Exit Function
  Wend
  Out Add_Hand_Shake, 7 'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                        'resets i/o req and disables data from the smc20's bus
  Next X
End If

End Function

Function SendBinary(Hex_Address, Axis, NUMBER, Bytes)

'this will send either 1 or 2 bytes, specified by the Bytes term
'AA use only
'This function will "hang up" if the chip is in motion - like a HOME or INDEX
'this can be avoided by checking the BUSY before issuing the command

If Axis = 1 Then
    Add_Hand_Shake = Hex_Address + 1
    ADD_LATCH = Hex_Address + 3
   
  If Bytes = 1 Then
    StartTime = Timer
    While AxisBusy(Hex_Address, Axis)    'wait for the chip to not be BUSY
     If Timer - StartTime > 1 Then SendBinary = 1: Exit Function
    Wend
    Out Add_Hand_Shake, 6          'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out ADD_LATCH, NUMBER Mod 256  'this latches the data on U7
    Out Add_Hand_Shake, 4          'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
    a = Inp(Hex_Address)           'BUSY is the odd bit here
    StartTime = Timer
    While AxisBusy(Hex_Address, Axis) = 0  'wait for the chip to be BUSY (accept the data)
       If Timer - StartTime > 1 Then SendBinary = 1: Exit Function
    Wend
    Out Add_Hand_Shake, 7   'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                            'resets i/o req
                            'disables data from the smc20's bus
  End If

  If Bytes = 2 Then
    StartTime = Timer
    While AxisBusy(Hex_Address, Axis)    'wait for the chip to not be BUSY
       If Timer - StartTime > 1 Then SendBinary = 1: Exit Function
    Wend
    Out Add_Hand_Shake, 6          'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out ADD_LATCH, NUMBER Mod 256  'this latches the data on U7
    Out Add_Hand_Shake, 4          'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
    StartTime = Timer
    While AxisBusy(Hex_Address, Axis) = 0   'wait for the chip to be BUSY (accept the data)
        If Timer - StartTime > 1 Then SendBinary = 1: Exit Function
    Wend
    Out Add_Hand_Shake, 7   'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                            'resets i/o req
                            'disables data from the smc20's bus
    While AxisBusy(Hex_Address, Axis) = 1   'wait for the chip to not be BUSY
    Wend
    Out Add_Hand_Shake, 6        'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out ADD_LATCH, NUMBER \ 256  'this latches the data on U7
    Out Add_Hand_Shake, 4        'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
    While AxisBusy(Hex_Address, Axis) = 0         'wait for the chip to be BUSY (accept the data)
    Wend
    Out Add_Hand_Shake, 7  'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                          'resets i/o req
                          'disables data from the smc20's bus
  End If
Else    'Axis = 2
        Add_Hand_Shake = Hex_Address + 1
        ADD_LATCH = Hex_Address + 5
  If Bytes = 1 Then
    StartTime = Timer
    While AxisBusy(Hex_Address, Axis) = 1   'wait for the chip to not be BUSY
       If Timer - StartTime > 1 Then SendBinary = 1: Exit Function
    Wend
    Out Add_Hand_Shake, 6          'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out ADD_LATCH, NUMBER Mod 256  'this latches the data on U7
    Out Add_Hand_Shake, 2          'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
    StartTime = Timer
    While AxisBusy(Hex_Address, Axis) = 0         'wait for the chip to be BUSY (accept the data)
       If Timer - StartTime > 1 Then SendBinary = 1: Exit Function
    Wend
    Out Add_Hand_Shake, 7          'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                            'resets i/o req
                            'disables data from the smc20's bus
  End If
 
  If Bytes = 2 Then
    StartTime = Timer
    While AxisBusy(Hex_Address, Axis) = 1          'wait for the chip to not be BUSY
       If Timer - StartTime > 1 Then SendBinary = 1: Exit Function
    Wend
    Out Add_Hand_Shake, 6    'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out ADD_LATCH, NUMBER Mod 256  'this latches the data on U7
    Out Add_Hand_Shake, 2    'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
    StartTime = Timer
    While AxisBusy(Hex_Address, Axis) = 0          'wait for the chip to be BUSY (accept the data)
       If Timer - StartTime > 1 Then SendBinary = 1: Exit Function
    Wend
    Out Add_Hand_Shake, 7      'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                               'resets i/o req
                             'disables data from the smc20's bus
    While AxisBusy(Hex_Address, Axis) = 1          'wait for the chip to not be BUSY
    Wend
    Out Add_Hand_Shake, 6         'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out ADD_LATCH, NUMBER \ 256  'this latches the data on U7
    Out Add_Hand_Shake, 2         'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
    While AxisBusy(Hex_Address, Axis) = 0         'wait for the chip to be BUSY (accept the data)
    Wend
    Out Add_Hand_Shake, 7 'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to HI
                          'resets i/o req
                          'disables data from the smc20's bus
  End If
End If

End Function

Function SendRun(Hex_Address, Axis)
 If (SendASCII(Hex_Address, Axis, "R")) Then SendRun = 1
 If (SendBinary(Hex_Address, Axis, 0, 1)) Then SendRun = 1
End Function

Sub SetOutputs(Hex_Address, Out6, Out5, Out4, Out3, Out2, Out1)
       Dim Address
   Address = Hex_Address + 7
   Total = Out6 * 32 + Out5 * 16 + Out4 * 8 + Out3 * 4 + Out2 * 2 + Out1
   Out Address, Total
End Sub

Function Initialize(Hex_Address, Axis)
'the 74HC373 chip may come up with the outputs in either a high or low state
'this subroutine will ensure that the outputs will be in the high state
'the SMC20 may get one byte of unknown data if the output was in the low state
If Axis = 1 Then
   WriteDataAddress = (Hex_Address + 3)
   AxisRequestMask = 4
Else
   WriteDataAddress = (Hex_Address + 5)
   AxisRequestMask = 2
   
End If

   For Count = 0 To 2
      Out Hex_Address + 1, 6
      Pause
      Out WriteDataAddress, Asc("Q")
      Pause
      Out (Hex_Address + 1), AxisRequestMask
      Pause
      Out (Hex_Address + 1), 7
      Pause
   Next Count
      
   If (SetBase(Hex_Address, Axis, 100)) Then Initialize = 1
   If (SetMax(Hex_Address, Axis, 249)) Then Initialize = 1
   If (SetAccel(Hex_Address, Axis, 80)) Then Initialize = 1
   If (SetDecel(Hex_Address, Axis, 80)) Then Initialize = 1
   If (SetDistance(Hex_Address, Axis, 5000)) Then Initialize = 1
   If (SetCW(Hex_Address, Axis)) Then Initialize = 1
   If (SetFactor(Hex_Address, Axis, 4)) Then Initialize = 1
   If (ZeroPosition(Hex_Address, Axis)) Then Initialize = 1
   SetOutputs Hex_Address, 0, 0, 0, 0, 0, 0
   
End Function
Function Verify(Hex_Address, Axis, a$)
  
   b = 0
   c = 1
 
If (SendASCII(Hex_Address, Axis, "V" + a$)) Then Verify = 1

While DBInOut(Hex_Address, Axis) = 1
   va = ReceiveByte(Hex_Address, Axis)
   Select Case c
   Case 1
     b = b + va
   Case 2
     b = b + va * 256
   Case 3
     b = b + va * 65536
   End Select
   c = c + 1
Wend
   Verify = b

End Function

Function VerifyProgram$(Hex_Address, Axis)
'AA use only
    a$ = ""
    b$ = ""
 
 If (SendASCII(Hex_Address, Axis, "VC")) Then VerifyProgram = 1
 a = ReceiveByte(Hex_Address, Axis)
   StartTime = Timer
   While a <> 74
   If Timer - StartTime > 1 Then VerifyProgram$ = 1: Exit Function
   If (SendASCII(Hex_Address, Axis, "VC")) Then VerifyProgram = 1
   a = ReceiveByte(Hex_Address, Axis)
   Wend
   
While DBInOut(Hex_Address, Axis) = 1

    a = ReceiveByte(Hex_Address, Axis)
    a$ = Chr$(a)
  
   Select Case a$
   
        Case "A"
        b$ = b$ & a$ & Mid(Str$(ReceiveByte(Hex_Address, Axis)), 1)
         
        Case "B"
        b$ = b$ & a$ & Mid(Str$(ReceiveByte(Hex_Address, Axis)), 1)
       
        Case "D"
        b$ = b$ & a$ & Mid(Str$(ReceiveByte(Hex_Address, Axis)), 1)

        Case "F"
        b$ = b$ & a$ & Mid(Str$(ReceiveByte(Hex_Address, Axis)), 1)
        
        Case "G"
        b$ = b$ & a$

        Case "H"
        b$ = b$ & a$
        a$ = Chr$(ReceiveByte(Hex_Address, Axis))
        a$ = Chr$(ReceiveByte(Hex_Address, Axis))
       
        Case "I"
        b$ = b$ & a$ & Mid(Str$(ReceiveByte(Hex_Address, Axis)), 1) & Mid(Str$(ReceiveByte(Hex_Address, Axis)), 1)

        Case "J"
        b$ = b$ & a$ & Mid(Str$(ReceiveByte(Hex_Address, Axis)), 2)
       
        Case "L"
        b$ = b$ & a$ & Mid(Str$(ReceiveByte(Hex_Address, Axis)), 1) & Mid(Str$(ReceiveByte(Hex_Address, Axis)), 1)
       
        Case "M"
        b$ = b$ & a$ & Mid(Str$(ReceiveByte(Hex_Address, Axis)), 1)
       
        Case "N"
        b$ = b$ & a$ & Mid(Str$((ReceiveByte(Hex_Address, Axis)) + (256 * (ReceiveByte(Hex_Address, Axis)))), 2)
       
        Case "Q"
           b$ = b$ & a
        
        Case "X"
        b$ = b$ & a$ & Mid(Str$((ReceiveByte(Hex_Address, Axis)) + (256 * (ReceiveByte(Hex_Address, Axis)))), 2)
        
        End Select
Wend
    For X = Len(b$) To 1 Step -1
       Character = Mid$(b$, X, 1)
       If Character <> "Q" Then Exit For
    Next X
    D$ = Left(b$, X + 1)
   VerifyProgram$ = D$
   
End Function
Function StoreProgram(Hex_Address, Axis, a$)
    b$ = ""
    c$ = a$
    Length = 0
     
  Length = Len(a$)
  If (SendASCII(Hex_Address, Axis, "E")) Then StoreProgram = 1
  If (SendBinary(Hex_Address, Axis, 0, 1)) Then StoreProgram = 1
  If (SendBinary(Hex_Address, Axis, 76, 1)) Then StorePrograam = 1


  For Index = 1 To Length
  Char$ = Mid$(a$, Index, 1)
   
    If Char$ = "A" Or Char$ = "a" Then GoSub SendAccel
    If Char$ = "B" Or Char$ = "b" Then GoSub SendBase
    If Char$ = "D" Or Char$ = "d" Then GoSub SendDecel
    If Char$ = "F" Or Char$ = "f" Then GoSub SendFactor
    If Char$ = "G" Or Char$ = "g" Then GoSub SendGo
    If Char$ = "H" Or Char$ = "h" Then GoSub SendHomeType
    If Char$ = "I" Or Char$ = "i" Then GoSub SendIfStatement
    If Char$ = "J" Or Char$ = "j" Then GoSub SendJogRateDivisor
    If Char$ = "L" Or Char$ = "l" Then GoSub SendLoopStatement
    If Char$ = "M" Or Char$ = "m" Then GoSub SendMax           ' Case "I"
    If Char$ = "N" Or Char$ = "n" Then GoSub SendDistance
    If Char$ = "Q" Or Char$ = "q" Then GoSub SendQuit
    If Char$ = "X" Or Char$ = "x" Then GoSub SendDelay
  
  Next Index

   For extra = Length To 76
      If (SendASCII(Hex_Address, Axis, "Q")) Then ProgramVerify = 1
   Next extra
   Exit Function

'SUBS
SendAccel:
    If (SendASCII(Hex_Address, Axis, "A")) Then ProgramVerify = 1
    Index = Index + 1
    Char$ = Mid$(a$, Index)
    Index = Index + DigitCount(Char$)
    If (SendBinary(Hex_Address, Axis, Val(Char$), 1)) Then ProgramVarify = 1
Return

SendBase:
    If (SendASCII(Hex_Address, Axis, "B")) Then ProgramVerify = 1
    Index = Index + 1
    Char$ = Mid$(a$, Index)
    Index = Index + DigitCount(Char$)
    If (SendBinary(Hex_Address, Axis, Val(Char$), 1)) Then ProgramVarify = 1
Return

SendDecel:
    If (SendASCII(Hex_Address, Axis, "D")) Then ProgramVerify = 1
    Index = Index + 1
    Char$ = Mid$(a$, Index)
    Index = Index + DigitCount(Char$)
    If (SendBinary(Hex_Address, Axis, Val(Char$), 1)) Then ProgramVarify = 1
Return

SendFactor:
    If (SendASCII(Hex_Address, Axis, "F")) Then ProgramVerify = 1
    Index = Index + 1
    Char$ = Mid$(a$, Index)
    Index = Index + DigitCount(Char$)
    If (SendBinary(Hex_Address, Axis, Val(Char$), 1)) Then ProgramVarify = 1
Return

SendGo:
    If (SendASCII(Hex_Address, Axis, "G")) Then ProgramVerify = 1
    Index = Index + 1
Return

SendHomeType:
    If (SendASCII(Hex_Address, Axis, "H")) Then ProgramVerify = 1
    Index = Index + 1
    Char$ = Mid$(a$, Index)
    Index = Index + DigitCount(Char$)
    If (SendBinary(Hex_Address, Axis, Val(Char$), 1)) Then ProgramVarify = 1
    Index = Index + 1
Return

SendIfStatement:
   If (SendASCII(Hex_Address, Axis, "I")) Then ProgramVerify = 1
    Index = Index + 1
    Char$ = Mid$(a$, Index)
    Index = Index + DigitCount(Char$)
    If (SendBinary(Hex_Address, Axis, Val(Char$), 1)) Then ProgramVarify = 1
    Index = Index + 1
    Char$ = Mid$(a$, Index)
    Index = Index + DigitCount(Char$)
    If (SendBinary(Hex_Address, Axis, Val(Char$), 1)) Then ProgramVarify = 1
Return

SendJogRateDivisor:
    If (SendASCII(Hex_Address, Axis, "J")) Then ProgramVerify = 1
    Index = Index + 1
    Char$ = Mid$(a$, Index)
    Index = Index + DigitCount(Char$)
    If (SendBinary(Hex_Address, Axis, Val(Char$), 1)) Then ProgramVarify = 1
Return

SendLoopStatement:
    If (SendASCII(Hex_Address, Axis, "L")) Then ProgramVerify = 1
    Index = Index + 1
    Char$ = Mid$(a$, Index)
    Index = Index + DigitCount(Char$)
    If (SendBinary(Hex_Address, Axis, Val(Char$), 1)) Then ProgramVarify = 1
    Index = Index + 1
    Char$ = Mid$(a$, Index)
    Index = Index + DigitCount(Char$)
    If (SendBinary(Hex_Address, Axis, Val(Char$), 1)) Then ProgramVarify = 1
Return

SendMax:
   If (SendASCII(Hex_Address, Axis, "M")) Then ProgramVerify = 1
   Index = Index + 1
   Char$ = Mid$(a$, Index)
   Index = Index + DigitCount(Char$)
   If (SendBinary(Hex_Address, Axis, Val(Char$), 1)) Then ProgramVarify = 1
Return

SendDistance:
    If (SendASCII(Hex_Address, Axis, "N")) Then ProgramVerify = 1
    Index = Index + 1
    Char$ = Mid$(a$, Index)
    Index = Index + DigitCount(Char$)
    If (SendBinary(Hex_Address, Axis, Val(Char$), 2)) Then ProgramVarify = 1
Return

SendQuit:
    If (SendASCII(Hex_Address, Axis, "Q")) Then ProgramVerify = 1
Return

SendDelay:
    If (SendASCII(Hex_Address, Axis, "X")) Then ProgramVerify = 1
    Index = Index + 1
    Char$ = Mid$(a$, Index)
    Index = Index + DigitCount(Char$)
    If (SendBinary(Hex_Address, Axis, Val(Char$), 2)) Then ProgramVarify = 1
Return
End Function

Function ZeroPosition(Hex_Address, Axis)
 If (SendASCII(Hex_Address, Axis, "Z")) Then ZeroPosition = 1
End Function

Function DigitCount(Char As String)
      
      Length = Len(Char)
    For Index = 1 To Length
      c = Asc(Mid(Char, Index, 1))
      'C = Asc(Char$)
     If c >= Asc("0") And c <= Asc("9") Then
       DigitCount = DigitCount + 1
    Else
       Exit For
     End If
   Next Index
End Function
