'** ANAHEIM AUTOMATION **
'PROGRAM: C500SUBS.BAS
'DATE: 8/8/96
'REVISION: 1.0
'BY: ALAN HARMON
'Revision:
'BY: Cody Brandel
'Date: 3/15/99

'**************************** SUBS *******************************
DECLARE SUB FinishMove (Hex.Address!, Axis!)
DECLARE SUB SetOutputs (Hex.Address!, Out6!, Out5!, Out4!, Out3!, Out2!, Out1!)
DECLARE SUB Pause ()

'*************************** FUNCTIONS *******************************
DECLARE FUNCTION AxisBusy! (Hex.Address!, Axis!)
DECLARE FUNCTION ByteCount! (a$)
DECLARE FUNCTION DBInOut! (Hex.Address!, Axis!)
DECLARE FUNCTION GetBaseRate! (Hex.Address!, Axis!, Base.Speed!, Max.Speed!)
DECLARE FUNCTION GetBaseSpeed! (Hex.Address!, Axis!)
DECLARE FUNCTION GetInput! (Hex.Address!, InputValue!)
DECLARE FUNCTION GetInputs! (Hex.Address!)
DECLARE FUNCTION GetMaxSpeed! (Hex.Address!, Axis!)
DECLARE FUNCTION GetProgram! (Hex.Address!, Axis!)
DECLARE FUNCTION GoRelative (Hex.Address!, Axis!)
DECLARE FUNCTION HomeType (Hex.Address!, Axis!, NUMBER!)
DECLARE FUNCTION HowManyAxes! (Hex.Address!)
DECLARE FUNCTION Initialize (Hex.Address!, Axis)
DECLARE FUNCTION JogRateDivisor (Hex.Address!, Axis, Divisor)
DECLARE FUNCTION MaxRate! ()
DECLARE FUNCTION NumberOfAxes! (Hex.Address!)
DECLARE FUNCTION ProgramRun ()
DECLARE FUNCTION QuitProgram (Hex.Address!, Axis!)
DECLARE FUNCTION ReceiveByte! (Hex.Address!, Axis!)
DECLARE FUNCTION SendASCII (Hex.Address!, Axis!, a$)
DECLARE FUNCTION SendBinary (Hex.Address!, Axis!, NUMBER!, Bytes!)
DECLARE FUNCTION SendRun (Hex.Address!, Axis!)
DECLARE FUNCTION SetAccel (Hex.Address!, Axis!, NUMBER!)
DECLARE FUNCTION SetBase (Hex.Address!, Axis!, NUMBER!)
DECLARE FUNCTION SetCW (Hex.Address!, Axis!)
DECLARE FUNCTION SetCCW (Hex.Address!, Axis!)
DECLARE FUNCTION SetDecel (Hex.Address!, Axis!, NUMBER!)
DECLARE FUNCTION SetDistance (Hex.Address!, Axis!, NUMBER!)
DECLARE FUNCTION SetFactor (Hex.Address!, Axis!, NUMBER!)
DECLARE FUNCTION SetMax (Hex.Address!, Axis!, NUMBER!)
DECLARE FUNCTION SetMotion (Hex.Address!, Axis!, Base.Speed!, Max.Speed!)
DECLARE FUNCTION SetPosition (Hex.Address!, Axis!, NUMBER!)
DECLARE FUNCTION Verify! (Hex.Address!, Axis!, a$)
DECLARE FUNCTION VerifyProgram$ (Hex.Address!, Axis!)
DECLARE FUNCTION ZeroPosition (Hex.Address!, Axis!)

'this program was written to control the AA2327 SMC20 (CLCI500) based board.
'it uses the binary mode of communications

'TO USE THIS FILE YOU NEED TO LOAD IT INTO YOUR MAIN PROGRAM
'FOR QUICKBASIC, AT THE COMMAND LINE TYPE QBASIC /L CLCISUBS.QLB
'FOR VISUAL BASIC, AT THE COMMAND LINE TYPE VBDOS /L CLCISUBS.QLB
'BE SURE TO DECLARE THE SUBS AND FUNCTIONS YOU ARE USING
'YOU MIGHT WANT TO COPY ALL THESE DECLARE STATEMENTS TO YOUR MAIN PROGRAM.
 

'PRINT Initialize(&H300, 1)
'PRINT Initialize(&H300, 2)
'PRINT VerifyProgram(&H300, 1)
'FOR N = 0 TO 3
'PRINT NumberOfAxes(&H300)
'PRINT SetMotion(&H300, 2, 1000, 10000)
'PRINT SetCW(&H300, 2)
'PRINT SetDistance(&H300, 2, 5000)
'PRINT GoRelative(&H300, 2)
'FinishMove &H300, 2
PRINT SetCCW(&H300, 1)
PRINT SetMotion(&H300, 1, 100, 220)
PRINT SetFactor(&H300, 1, 10)
PRINT SetDistance(&H300, 1, 1000)
'PRINT GoRelative(&H300, 1)
'FinishMove &H300, 1
'SetOutputs &H300, 1, 1, 1, 0, 0, 0
'PRINT GetInput(&H300, 2)
'PRINT GetBaseSpeed(&H300, 1)
'PRINT GetBaseRate(&H300, 1, 100, 220)
'PRINT GetProgram(&H300, 1)


DO WHILE GetInput(&H300, 1) = 1
PRINT GoRelative(&H300, 1)
FinishMove &H300, 1
LOOP

'PRINT GetBaseSpeed(&H300, 2)
'PRINT GetBaseRate(&H300, 2, 100, 220)
'PRINT GetProgram(&H300, 2)

'NEXT

FUNCTION AxisBusy (Hex.Address, Axis)
'this will return a 1 if it is BUSY meaning LOW
'this will return a 0 if it is not BUSY meaning HIGH

a = INP(Hex.Address)                          'BUSY is the odd bit here
  IF Axis = 1 THEN
       IF a MOD 2 = 1 THEN
                AxisBusy = 0             'not busy
        ELSE
                AxisBusy = 1
        END IF
  ELSE
        IF a >= 8 THEN a = a - 8
        IF a >= 4 THEN
                AxisBusy = 0
        ELSE
                AxisBusy = 1
        END IF
  END IF
END FUNCTION

FUNCTION ByteCount (a$)
'this counts the bytes for programming the SMC20.
'AA use only

        SELECT CASE a$

        CASE "ACCL"
        ByteCount = 2

        CASE "BASE"
        ByteCount = 6
       
        CASE "DECL"
        ByteCount = 2

        CASE "GO"
        ByteCount = 1
     
        CASE "GOTO"             'LIKE A LOOP WITH A 0
        ByteCount = 3

        CASE "HOME"
        ByteCount = 2

        CASE "INPT"
        ByteCount = 3
    
        CASE "LOOP"
        ByteCount = 3

        CASE "MAX"
        ByteCount = 6
     
        CASE "NUM"
        ByteCount = 3

        CASE "OUT"
        ByteCount = 3
     
        CASE "POS"
        ByteCount = 3

        CASE "QUIT"
        ByteCount = 1
     
        CASE "UNTL"             '(WAIT)
        ByteCount = 2
     
        CASE "WAIT"             '(EXPEND)
        ByteCount = 3
     
        CASE "SETZ"
        ByteCount = 1

        CASE "DIR+"
        ByteCount = 1
      
        CASE "DIR-"
        ByteCount = 1
       
        CASE ELSE
        ByteCount = 0

        END SELECT

END FUNCTION

FUNCTION DBInOut (Hex.Address, Axis)
'this will return a 1 if it is ready to SEND data meaning LOW
'this will return a 0 if it is ready to RECEIVE data meaning HIGH
'AA use only

  ADDRESS = Hex.Address
  a = INP(Hex.Address)
  IF Axis = 1 THEN
        IF a >= 8 THEN a = a - 8
        IF a >= 4 THEN a = a - 4
        IF a >= 2 THEN
                DBInOut = 0
        ELSE
                 DBInOut = 1
        END IF
  ELSE                                    'Axis = 2
        IF a >= 8 THEN
                 DBInOut = 0
        ELSE
                 DBInOut = 1
        END IF
  END IF
END FUNCTION

SUB FinishMove (Hex.Address, Axis)
        WHILE AxisBusy(Hex.Address, Axis)
        WEND
END SUB

FUNCTION GetBaseRate (Hex.Address, Axis, BaseSpeed, MaxSpeed)
'this selects the appropriate base rate setting
'AA use only

  crystal! = 1.1E+07
 
  Factor.A = INT(crystal! / (MaxSpeed * (8100 - 30 * 255)))
 
  BaseRate = INT((8100 - crystal! / (BaseSpeed * Factor.A)) / 30 + .5)
  IF BaseRate < 1 THEN BaseRate = 1
  BaseRate = BaseRate
END FUNCTION

FUNCTION GetBaseSpeed (Hex.Address, Axis)
        'this returns the actual base speed

  IF (SendASCII(Hex.Address, Axis, "VF")) THEN GetBaseSpeed = 1
  Factor.C = ReceiveByte(Hex.Address, Axis)

  IF (SendASCII(Hex.Address, Axis, "VB")) THEN GetBaseSpeed = 1
  BASE.RTE = ReceiveByte(Hex.Address, Axis)

  crystal! = 1.1E+07

  GetBaseSpeed = (crystal! / (Factor.C * (8100 - 30 * BASE.RTE)))
        'this calculates the actual speed
END FUNCTION

FUNCTION GetInput (Hex.Address, InputValue)
'If GetInput is a 0 then the Input is off
'If GetInput is a 1 then the Input is off
   ADDRESS = Hex.Address + 6
   Value = 63 - INP(ADDRESS)
   Result = (Value \ (2 ^ (InputValue - 1)) AND 1)
   GetInput = Result
END FUNCTION

FUNCTION GetInputs (Hex.Address)
        ADDRESS = Hex.Address + 6
        GetInputs = (63 - INP(ADDRESS))
END FUNCTION

FUNCTION GetMaxSpeed (Hex.Address, Axis)
'this returns the actual max speed

  IF (SendASCII(Hex.Address, Axis, "VF")) THEN GetMaxSpeed = 1
  FactorB = ReceiveByte(Hex.Address, Axis)

  IF (SendASCII(Hex.Address, Axis, "VM")) THEN GetMaxSpeed = 1
  MaxRte = ReceiveByte(Hex.Address, Axis)

crystal! = 1.1E+07

GetMaxSpeed = (crystal! / (FactorB * (8100 - 30 * MaxRte)))
        'this calculates the actual speed

END FUNCTION

FUNCTION GetProgram (Hex.Address, Axis)
'AA use only
 
  PRINT : PRINT
  PRINT "data bus - "; DBInOut(Hex.Address, Axis)
  IF (SendASCII(Hex.Address, Axis, "VC")) THEN GetProgram = 1
  PRINT "data bus - "; DBInOut(Hex.Address, Axis)
  WHILE DBInOut(Hex.Address, Axis) = 1
        Opcode = ReceiveByte(Hex.Address, Axis)
        PRINT "INDEX NUMBER: "; CHR$(Opcode); Opcode,
        PRINT "data bus - "; DBInOut(Hex.Address, Axis)
  WEND

END FUNCTION

FUNCTION GoRelative (Hex.Address, Axis)
 IF (SendASCII(Hex.Address, Axis, "G")) THEN GoRelative = 1
END FUNCTION

FUNCTION HomeType (Hex.Address, Axis, NUMBER)
 IF (SendASCII(Hex.Address, Axis, "H")) THEN HomeType = 1
 IF (SendBinary(Hex.Address, Axis, NUMBER, 1)) THEN HomeType = 1
END FUNCTION

FUNCTION Initialize (Hex.Address, Axis)
'the 74HC373 chip may come up with the outputs in either a high or low state
'this function will ensure that the outputs will be in the high state
'the SMC20 may get one byte of unknown data if the output was in the low state
'This function also sets the motion to known values
'If the SMC 20 does not take any one of the values a 1 will be returned

  IF Axis = 1 THEN
     WriteDataAddress = (Hex.Address + 3)
     AxisRequestMask = 4
  ELSE
    WriteDataAddress = (Hex.Address + 5)
    AxisRequestMask = 2
  END IF
  
  FOR Count = 0 TO 2
  OUT (Hex.Address + 1), 6
  Pause
  OUT WriteDataAddress, ASC("Q")
  Pause
  OUT (Hex.Address + 1), AxisRequestMask
  Pause
  OUT (Hex.Address + 1), 7
  Pause
NEXT Count
  IF (SetAccel(Hex.Address, Axis, 10)) THEN Initialize = 1
  IF (SetDecel(Hex.Address, Axis, 10)) THEN Initialize = 1
  IF (SetMotion(Hex.Address, Axis, 400, 200)) THEN Initialize = 1
  IF (SetDistance(Hex.Address, Axis, 400)) THEN Initialize = 1
  IF (SetCW(Hex.Address, Axis)) THEN Initialize = 1
  SetOutputs Hex.Address, 0, 0, 0, 0, 0, 0
  IF (ZeroPosition(Hex.Address, Axis)) THEN Initialize = 1

END FUNCTION

FUNCTION JogRateDivisor (Hex.Address, Axis, Divisor)
 IF (SendASCII(Hex.Address, Axis, "J")) THEN JogRateDivisor = 1
 IF (SendBinary(Hex.Address, Axis, Divisor, 1)) THEN JogRateDivisor = 1

END FUNCTION

FUNCTION NumberOfAxes (Hex.Address)
'this function will send an INDEX NUMBER to each potential axis
'if the number can be read back, then that axis is indeed valid.
'this function will return a 1 if axis 1 is valid
'                          a 2 if axis 1 and axis 2 is valid
'                          a 99 if axis 1 is NOT valid but axis 2 is
 
'************************ AXIS 1 TEST ************************
  NUMBER = 12345
  Axis = 1
  Add.Hand.Shake = Hex.Address + 1
  Add.Latch = Hex.Address + 3

  
  a$ = "N"
  IF (SendASCII(Hex.Address, Axis, a$)) THEN GOTO NoAxis
  IF (SendBinary(Hex.Address, Axis, NUMBER, 2)) THEN GOTO NoAxis
  
  a$ = "VN"
  IF (SendASCII(Hex.Address, Axis, a$)) THEN GOTO NoAxis

'receive the number
  ADDRESS = Hex.Address + 2
  WHILE AxisBusy(Hex.Address, Axis)
  WEND
  OUT Hex.Address + 1, 5   'A:I/O REQ LOW, B:I/O REQ HI, write control HIGH

  DO
  DBCheck = INP((Hex.Address) AND 3)
  LOOP UNTIL (DBCheck = 0)

  a = INP(ADDRESS)                          'read the data
  DBCheck = INP(Hex.Address)
  OUT Hex.Address + 1, 7   'A:I/O REQ HI, B:I/O REQ HI, write control HIGH

  WHILE AxisBusy(Hex.Address, Axis)
  WEND
  OUT Hex.Address + 1, 5   'A:I/O REQ LOW, B:I/O REQ HI, write control HIGH
  DO
  DBCheck = INP((Hex.Address) AND 3)
  LOOP UNTIL (DBCheck = 0)
  
  B = INP(ADDRESS)
  a = a + B * 256
  WHILE AxisBusy(Hex.Address, Axis) = 0
  WEND
NoAxis:
   AxesCount = 0

  OUT Hex.Address + 1, 7   'A:I/O REQ HI, B:I/O REQ HI, write control HIGH

  IF a = 12345 THEN AxesCount = 1

'************************ AXIS 2 TEST ************************
  Add.Hand.Shake = Hex.Address + 1
  Add.Latch = Hex.Address + 5
  a$ = "N"
  NUMBER = 54321
  Axis = 2

'SEND "N"
    WHILE AxisBusy(Hex.Address, Axis)      'wait for not busy
    WEND
    IF (SendASCII(Hex.Address, Axis, a$)) THEN GOTO NoAxis2
'SEND NUMBER
    IF (SendBinary(Hex.Address, Axis, NUMBER, 2)) THEN GOTO NoAxis2
'SEND "VN"
    a$ = "VN"
    IF (SendASCII(Hex.Address, Axis, a$)) THEN GOTO NoAxis2

'RECEIVE NUMBER
    ADDRESS = Hex.Address + 4
    WHILE AxisBusy(Hex.Address, Axis)
    WEND

    OUT Hex.Address + 1, 3   'A:I/O REQ HI, B:I/O REQ LOW, write control HIGH

    DO
    DBCheck = INP((Hex.Address) AND 12)
    LOOP UNTIL (DBCheck = 0)
   
    a = INP(ADDRESS)                          'read the data
    WHILE AxisBusy(Hex.Address, Axis) = 0 'wait for busy
    WEND
    OUT Hex.Address + 1, 7   'A:I/O REQ HI, B:I/O REQ HI, write control HIGH
    WHILE AxisBusy(Hex.Address, Axis)  'wait for not busy
    WEND
   
    OUT Hex.Address + 1, 3   'A:I/O REQ HI, B:I/O REQ LOW, write control HIGH
   
    DO
    DBCheck = INP((Hex.Address) AND 12)
    LOOP UNTIL (DBCheck = 0)
   
    B = INP(ADDRESS)
    a = a + B * 256
   OUT Hex.Address + 1, 7   'A:I/O REQ HI, B:I/O REQ HI, write control HIGH

NoAxis2:
  IF (a = 54321) AND (AxesCount = 1) THEN AxesCount = 2
  IF (a = 54321) AND (AxesCount = 0) THEN AxesCount = 99

  'IF AxesCount = 99 THEN SOMETHING IS WRONG WITH AXIS 1 BUT AXIS 2 IS OK

   NumberOfAxes = AxesCount

END FUNCTION

SUB Pause
  StartTime = TIMER
  WHILE TIMER - StartTime < .1
  WEND
END SUB

FUNCTION ProgramRun
  Axis = 1
  ADDRESS = &H300
  IF (SendASCII(ADDRESS, Axis, "R")) THEN ProgramRun = 1
  IF (SendBinary(ADDRESS, Axis, 0, 1)) THEN ProgramRun = 1
END FUNCTION

FUNCTION QuitProgram (Hex.Address, Axis)
  a$ = "Q"
 IF (SendASCII(Hex.Address, Axis, a$)) THEN QuitProgram = 1

END FUNCTION

FUNCTION ReceiveByte (Hex.Address, Axis)
'this is to receive one byte of data from the smc20 chip
'AA use only

        'we check for the busy to be HIGH
        'then we bring the i/o req low (meaning ready)
        'the smc20 brings the busy low and we check for this
        'then we read the data
        'then we bring the i/o req high
 
   IF Axis = 1 THEN
        ADDRESS = Hex.Address + 2
   ELSE                                 'Axis = 2
        ADDRESS = Hex.Address + 4
   END IF
  WHILE AxisBusy(Hex.Address, Axis)
  WEND

  IF Axis = 1 THEN
  OUT Hex.Address + 1, 5   'A:I/O REQ LOW, B:I/O REQ HI, write control HIG

  DO
  DBCheck = INP((Hex.Address) AND 3)
  LOOP WHILE (DBCheck)
 
  a = INP(ADDRESS)                          'read the data
  OUT Hex.Address + 1, 7   'A:I/O REQ HI, B:I/O REQ HI, write control HIGH
                        'resets i/o req
                        'disables data from the smc20's bus
  DO
  DBCheck = INP((Hex.Address) AND 1)
  LOOP WHILE (DBCheck)
  ReceiveByte = a

ELSE            'axis = 2
  OUT Hex.Address + 1, 3   'A:I/O REQ HI, B:I/O REQ LOW, write control HIGH
  DO
  DBCheck = INP((Hex.Address) AND 3)
  LOOP WHILE (DBCheck)
 
  a = INP(ADDRESS)                          'read the data
  OUT Hex.Address + 1, 7   'A:I/O REQ HI, B:I/O REQ HI, write control HIGH
                        'resets i/o req
                        'disables data from the smc20's bus
  ReceiveByte = a
END IF

END FUNCTION

FUNCTION SendASCII (Hex.Address, Axis, a$)
'AA use only
'This function will "hang up" if the chip is in motion - like a HOME or INDEX
'this can be avoided by checking the BUSY before issuing the command

IF Axis = 1 THEN
  Add.Hand.Shake = Hex.Address + 1
  Add.Latch = Hex.Address + 3

  FOR X = 1 TO LEN(a$)
   
    StartTime = TIMER
    WHILE AxisBusy(Hex.Address, Axis) = 1   'wait for the chip to not be BUSY
        IF TIMER - StartTime > .1 THEN SendASCII = 1: EXIT FUNCTION
    WEND                                '(a logic 1)
   
    OUT Add.Hand.Shake, 6    'this sets the A:I/O REQ to HI, B:I/O REQ to HI
                             'write control to LOW
    OUT Add.Latch, ASC(MID$(a$, X, 1))  'this latches the data on U7
    OUT Add.Hand.Shake, 4 'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
    WHILE AxisBusy(Hex.Address, Axis) = 0     'wait for the chip to be BUSY
    WEND                                  '(a logic 0) (it accepts the data)
    OUT Add.Hand.Shake, 7  'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                        'resets i/o req and disables data from the smc20's bus
  NEXT X
END IF

IF Axis = 2 THEN
  Add.Hand.Shake = Hex.Address + 1
  Add.Latch = Hex.Address + 5
  FOR X = 1 TO LEN(a$)
    StartTime = TIMER
  WHILE AxisBusy(Hex.Address, Axis) = 1   'wait for the chip to not be BUSY
    IF TIMER - StartTime > .1 THEN SendASCII = 1
  WEND
  OUT Add.Hand.Shake, 6 'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
  OUT Add.Latch, ASC(MID$(a$, X, 1))  'this latches the data on U7
  OUT Add.Hand.Shake, 2 'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
     StartTime = TIMER
  WHILE AxisBusy(Hex.Address, Axis) = 0     'wait for the chip to be BUSY (accept the data)
     IF TIMER - StartTime > .1 THEN SendASCII = 1: EXIT FUNCTION
   '  IF SendASCII = 1 THEN GOTO over
  WEND
  OUT Add.Hand.Shake, 7 'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                        'resets i/o req and disables data from the smc20's bus
  NEXT X
END IF
over:

END FUNCTION

FUNCTION SendBinary (Hex.Address, Axis, NUMBER, Bytes)
'this will send either 1 or 2 bytes, specified by the Bytes term
'AA use only
'This function will "hang up" if the chip is in motion - like a HOME or INDEX
'this can be avoided by checking the BUSY before issuing the command

IF Axis = 1 THEN
        Add.Hand.Shake = Hex.Address + 1
        Add.Latch = Hex.Address + 3
  IF Bytes = 1 THEN
     StartTime = TIMER
    WHILE AxisBusy(Hex.Address, Axis) = 1   'wait for the chip to not be BUSY
        IF TIMER - StartTime > 1 THEN SendBinary = 1: EXIT FUNCTION
    WEND
    OUT Add.Hand.Shake, 6          'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    OUT Add.Latch, NUMBER MOD 256  'this latches the data on U7
    OUT Add.Hand.Shake, 4          'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
    a = INP(Hex.Address)           'BUSY is the odd bit here
    WHILE AxisBusy(Hex.Address, Axis) = 0  'wait for the chip to be BUSY (accept the data)
    WEND
    OUT Add.Hand.Shake, 7   'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                            'resets i/o req
                            'disables data from the smc20's bus
  END IF

  IF Bytes = 2 THEN
    WHILE AxisBusy(Hex.Address, Axis) = 1   'wait for the chip to not be BUSY
    WEND
    OUT Add.Hand.Shake, 6          'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    OUT Add.Latch, NUMBER MOD 256  'this latches the data on U7
    OUT Add.Hand.Shake, 4          'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
    WHILE AxisBusy(Hex.Address, Axis) = 0   'wait for the chip to be BUSY (accept the data)
    WEND
    OUT Add.Hand.Shake, 7   'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                            'resets i/o req
                            'disables data from the smc20's bus
    WHILE AxisBusy(Hex.Address, Axis) = 1   'wait for the chip to not be BUSY
    WEND
    OUT Add.Hand.Shake, 6        'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    OUT Add.Latch, NUMBER \ 256  'this latches the data on U7
    OUT Add.Hand.Shake, 4        'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
    WHILE AxisBusy(Hex.Address, Axis) = 0         'wait for the chip to be BUSY (accept the data)
    WEND
    OUT Add.Hand.Shake, 7  'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                          'resets i/o req
                          'disables data from the smc20's bus
  END IF
ELSE    'Axis = 2
        Add.Hand.Shake = Hex.Address + 1
        Add.Latch = Hex.Address + 5
  IF Bytes = 1 THEN
    WHILE AxisBusy(Hex.Address, Axis) = 1   'wait for the chip to not be BUSY
    WEND
    OUT Add.Hand.Shake, 6          'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    OUT Add.Latch, NUMBER MOD 256  'this latches the data on U7
    OUT Add.Hand.Shake, 2          'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
      StartTime = TIMER
    WHILE AxisBusy(Hex.Address, Axis) = 0         'wait for the chip to be BUSY (accept the data)
    IF TIMER - StartTime > 1 THEN SendBinary = 1: EXIT FUNCTION
    WEND
    OUT Add.Hand.Shake, 7          'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                            'resets i/o req
                            'disables data from the smc20's bus
  END IF
 
  IF Bytes = 2 THEN
    WHILE AxisBusy(Hex.Address, Axis) = 1          'wait for the chip to not be BUSY
    WEND
    OUT Add.Hand.Shake, 6    'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    OUT Add.Latch, NUMBER MOD 256  'this latches the data on U7
    OUT Add.Hand.Shake, 2    'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
      StartTime = TIMER
    WHILE AxisBusy(Hex.Address, Axis) = 0          'wait for the chip to be BUSY (accept the data)
       IF TIMER - StartTime > 1 THEN SendBinary = 1: EXIT FUNCTION
    WEND
    OUT Add.Hand.Shake, 7      'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                               'resets i/o req
                             'disables data from the smc20's bus
    WHILE AxisBusy(Hex.Address, Axis) = 1          'wait for the chip to not be BUSY
    WEND
    OUT Add.Hand.Shake, 6         'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    OUT Add.Latch, NUMBER \ 256  'this latches the data on U7
    OUT Add.Hand.Shake, 2         'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
    WHILE AxisBusy(Hex.Address, Axis) = 0         'wait for the chip to be BUSY (accept the data)
    WEND
    OUT Add.Hand.Shake, 7 'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to HI
                          'resets i/o req
                          'disables data from the smc20's bus
  END IF
END IF
END FUNCTION

FUNCTION SendRun (Hex.Address, Axis)
 IF (SendASCII(Hex.Address, Axis, "R")) THEN SendRun = 1
 IF (SendBinary(Hex.Address, Axis, 0, 1)) THEN SendRun = 1
END FUNCTION

 FUNCTION SetAccel (Hex.Address, Axis, NUMBER)
 IF (SendASCII(Hex.Address, Axis, "A")) THEN SetAccel = 1
 IF (SendBinary(Hex.Address, Axis, NUMBER, 1)) THEN SetAccel = 1
END FUNCTION

FUNCTION SetBase (Hex.Address, Axis, NUMBER)
'this send the base rate
'AA use only
 IF (SendASCII(Hex.Address, Axis, "B")) THEN SetBase = 1
 IF (SendBinary(Hex.Address, Axis, NUMBER, 1)) THEN SetBase = 1
END FUNCTION

FUNCTION SetCCW (Hex.Address, Axis)
   IF (SendASCII(Hex.Address, Axis, "-")) THEN SetCCW = 1
END FUNCTION

FUNCTION SetCW (Hex.Address, Axis)
   IF (SendASCII(Hex.Address, Axis, "+")) THEN SetCW = 1
END FUNCTION

FUNCTION SetDecel (Hex.Address, Axis, NUMBER)
 IF (SendASCII(Hex.Address, Axis, "D")) THEN SetDecel = 1
 IF (SendBinary(Hex.Address, Axis, NUMBER, 1)) THEN SetDecel = 1
END FUNCTION

FUNCTION SetDistance (Hex.Address, Axis, NUMBER)
 IF (SendASCII(Hex.Address, Axis, "N")) THEN SetDistance = 1
 IF (SendBinary(Hex.Address, Axis, NUMBER, 2)) THEN SetDistance = 1
END FUNCTION

FUNCTION SetFactor (Hex.Address, Axis, NUMBER)
 IF (SendASCII(Hex.Address, Axis, "F")) THEN SetFactor = 1
 IF (SendBinary(Hex.Address, Axis, NUMBER, 1)) THEN SetFactor = 1
END FUNCTION

FUNCTION SetMax (Hex.Address, Axis, NUMBER)
'AA use only
 IF (SendASCII(Hex.Address, Axis, "M")) THEN SetMax = 1
 IF (SendBinary(Hex.Address, Axis, NUMBER, 1)) THEN SetMax = 1
END FUNCTION

FUNCTION SetMotion (Hex.Address, Axis, BaseSpeed, MaxSpeed)
  crystal! = 1.1E+07
  IF BaseSpeed > 20000 THEN Base.Speed = 20000
  IF BaseSpeed < 5 THEN Base.Speed = 5
  IF MaxSpeed > 24444 THEN Max.Speed = 24444
  IF MaxSpeed < 100 THEN Max.Speed = 100

  FactorA = INT(crystal! / (MaxSpeed * (8100 - 30 * 255)))
        'truncated not rounded
        'this calculates the highest factor that can be used

'  PRINT "Factor: "; FactorA

  MaxRte = INT((8100 - crystal! / (MaxSpeed * FactorA)) / 30 + .5)
        'this calculates the closest speed to that chosen
        'this rounds to the closest speed

'  PRINT "Max.Rate: "; MaxRte

  BaseRte = INT((8100 - crystal! / (BaseSpeed * FactorA)) / 30 + .5)
        'this calculates the closest speed to that chosen
        'this rounds to the closest speed
  IF BaseRte < 1 THEN BaseRte = 1
        'this is the case that the base speed asked for is too small
  IF BaseRte > 254 THEN BaseRte = 254

'  PRINT "Base.Rate: "; BaseRte

  IF (SetBase(Hex.Address, Axis, BaseRte)) THEN SetMotion = 1
  IF (SetMax(Hex.Address, Axis, MaxRte)) THEN SetMotion = 1
  IF (SetFactor(Hex.Address, Axis, FactorA)) THEN SetMotion = 1
END FUNCTION

SUB SetOutputs (Hex.Address, Out6, Out5, Out4, Out3, Out2, Out1)
   ADDRESS = Hex.Address + 7
   Total = Out6 * 32 + Out5 * 16 + Out4 * 8 + Out3 * 4 + Out2 * 2 + Out1
   OUT ADDRESS, Total
END SUB

FUNCTION SetPosition (Hex.Address, Axis, NUMBER)
 IF (SendASCII(Hex.Address, Axis, "P")) THEN SetPostion = 1
 IF (SendBinary(Hex.Address, Axis, NUMBER, 2)) THEN SetPosition = 1
END FUNCTION

FUNCTION Verify (Hex.Address, Axis, a$)
  
   B = 0
   c = 1

 IF (SendASCII(Hex.Address, Axis, ",V" + a$)) THEN Verify = 1

WHILE DBInOut(Hex.Address, Axis) = 1
   a = ReceiveByte(Hex.Address, Axis)
   SELECT CASE c
   CASE 1
     B = B + a
   CASE 2
     B = B + a * 256
   CASE 3
     B = B + a * 65536
   END SELECT
   c = c + 1
WEND
   Verify = B

END FUNCTION

FUNCTION VerifyProgram$ (Hex.Address, Axis)
'AA use only
    a$ = ""
    B$ = ""
IF (SendASCII(Hex.Address, Axis, "VC")) THEN VerifyProgam = 1

  ' A = ReceiveByte(Hex.Address, Axis)
WHILE DBInOut(Hex.Address, Axis) = 1
   B = GetMaxSpeed(Hex.Address, Axis)
   a = ReceiveByte(Hex.Address, Axis)
   a$ = CHR$(a)
  
   SELECT CASE a$
   
        CASE "A"
        'B$ = B$ + A$ + CHR$(ReceiveByte)

        CASE "B"
        'B$ = B$ + A$ + CHR$(ReceiveByte)
       
        CASE "D"
        'B$ = B$ + A$ + CHR$(ReceiveByte)

        CASE "F"
        'B$ = B$ + A$ + CHR$(ReceiveByte)
        
        CASE "G"
        B$ = B$ + a$

        CASE "H"
        B$ = B$ + a$
        'A$ = CHR$(ReceiveByte)
        'A$ = CHR$(ReceiveByte)
       
        CASE "I"
        'B$ = B$ + A$ + STR$(ReceiveByte + 256 * ReceiveByte)

        CASE "J"
        'B$ = B$ + A$ + STR$(ReceiveByte)
       
        CASE "L"
        'B$ = B$ + A$ + STR$(ReceiveByte + 256 * ReceiveByte)
       
        CASE "M"
        'B$ = B$ + A$ + STR$(ReceiveByte)
       
        CASE "N"
        'B$ = B$ + A$ + STR$(ReceiveByte + 256 * ReceiveByte)
       
        CASE "Q"
        B$ = B$ + a$
       
        CASE "X"
        'B$ = B$ + A$ + STR$(ReceiveByte + 256 * ReceiveByte)
                                     
        END SELECT
WEND
   VerifyProgram$ = B$

END FUNCTION

FUNCTION ZeroPosition (Hex.Address, Axis)
 IF (SendASCII(Hex.Address, Axis, "Z")) THEN ZeroPositon = 1
END FUNCTION

