/* *** ANAHEIM AUTOMATION ***
   Filename: CLCI500.H
   Programmer: Alan Harmon
   Date: 1/15/97
   Time: 3:30pm
   Version: 2.02
   Revised by: Cody Brandel
   Date: 3/1/99
   Version 2.01 changes
        include adding GET_INPUT, and correcting timing for faster computers
        and defining the function MOTION
   Version 2.02 changes
        added JOG function

   This is the header file for the  Computer Indexer Board CLCI500
*/

#if ! defined CLCI500_H
#define CLCI500_H

#define  not(condition)  (!(condition))
#define  inc(scalar) (++(scalar))
#define  SuccessValue  (0)
#define  Success()  return (SuccessValue)
#define  FailureValue (not(SuccessValue))
#define  Failure()  return (FailureValue)
#define  FailIf(c)  if (c)  Failure()
#define  until(condition) while(not(condition))
#define  or  ||
#define  and  &&
typedef unsigned char byte;
typedef byte result;


int    AxisBusy(int Axis);
result FinishMove(int Axis, unsigned int Duration);
int    GetInput(int InputValue);
int    GetInputs(void);
int    GetNumberOfAxes(void);
result GoHome(int Axis, int Type);
result GoRelative(int Axis);
result SetCWDir(int Axis);
result SetCCWDir(int Axis);
result InitializeAxis(int Axis);
result SetAccel(int Axis, int Value);
result SetDecel(int Axis, int Value);
result SetDistance(int Axis, int Distance);
result SetJogDivisor(int Axis, int Value);
result SetMotion(int Axis, int Base, int Max);
int    SetOutputs(int out6, int out5, int out4, int out3, int out2, int out1);
result SetPosition(int Axis, int Number);
result ZeroPosition(int Axis);

result SetBase(int Axis, int Value);
result SetFactor(int Axis, int Value);
result SetMax(int Axis, int Value);

#endif